# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_data.ipynb.

# %% auto 0
__all__ = ['catdists', 'datasplit']

# %% ../nbs/10_data.ipynb 6
#| export


# %% ../nbs/10_data.ipynb 8
from typing import Union

# %% ../nbs/10_data.ipynb 11
#| export

# %% ../nbs/10_data.ipynb 13
try: import numpy as np
except ImportError: ...

try: import pandas as pd
except ImportError: ...

# %% ../nbs/10_data.ipynb 15
#| export


# %% ../nbs/10_data.ipynb 17
#| export


# %% ../nbs/10_data.ipynb 19
from ltyp import ints, array, tensor

# %% ../nbs/10_data.ipynb 21
from .atyp import XYArray, LabelArray
from .util import idxperm

# %% ../nbs/10_data.ipynb 24
def catdists(data: XYArray, n: int) -> LabelArray:
    '''Categorize data by distances from the origin into n classes.'''
    dist = np.linalg.norm(data, axis=1)
    return pd.qcut(dist, q=n, labels=False, duplicates='drop')

# %% ../nbs/10_data.ipynb 26
def datasplit(data, splits: ints, retdfs: bool = False, seed: int = 3) -> tuple[Union[array, tensor], ...]:
    els = data.shape[0]
    idx = idxperm(els, *splits, seed=seed)
    if retdfs: return tuple(data.iloc[i] for i in idx)
    try: return tuple(data[i] for i in idx)
    except: return idx

# %% ../nbs/10_data.ipynb 28
#| export
